/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.search;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.search.boundary.AbstractBenutzerSuchparameterSearchParameters;
import de.ivu.elect.business.search.boundary.BenutzerSuchparameterChangeEvent;
import de.ivu.elect.business.search.boundary.BenutzerSuchparameterConversationStore;
import de.ivu.elect.business.search.boundary.BenutzerSuchparameterExtendedDAO;
import de.ivu.elect.business.search.boundary.BenutzerSuchparameterSearch;
import de.ivu.elect.business.search.boundary.BenutzerSuchparameterSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.search.entity.BenutzerSuchparameter;
import de.ivu.elect.business.search.entity.BenutzerSuchparameterMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractBenutzerSuchparameterSearchView.COMPONENT_NAME)
@View(viewId = AbstractBenutzerSuchparameterSearchView.VIEW_ID, useCase = UseCasePermission.BENUTZER_SUCHPARAMETER_SEARCH)
public abstract class AbstractBenutzerSuchparameterSearchView extends AbstractElectSearchView<BenutzerSuchparameter> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerSuchparameterSearchView";
  
  public static final String VIEW_ID = "/search/benutzer-suchparameter-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractBenutzerSuchparameterSearchView requestHandler;

  @Inject
  private transient BenutzerSuchparameterExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(BenutzerSuchparameterConversationStore.class)
  protected transient BenutzerSuchparameterConversationStore conversationStore;

  @Inject
  protected transient BenutzerSuchparameterSearch search;

  @Inject
  @ConversationGroup(AbstractBenutzerSuchparameterSearchParameters.class)
  protected transient BenutzerSuchparameterSearchParameters searchParameters;

  @Inject
  protected transient BenutzerSuchparameterMeta entityMeta;

  public AbstractBenutzerSuchparameterSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public BenutzerSuchparameter getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(BenutzerSuchparameter entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public BenutzerSuchparameterSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<BenutzerSuchparameter> getEagerLoadingCollector() {
    return EagerLoadingCollector.<BenutzerSuchparameter> create();
  }

  @Override
  public List<BenutzerSuchparameter> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<BenutzerSuchparameter> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onBenutzerSuchparameterChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) BenutzerSuchparameterChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractBenutzerSuchparameterSearchView {

    @View
    @Inject
    private transient Instance<AbstractBenutzerSuchparameterSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractBenutzerSuchparameterSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
